#!/usr/bin/php -q
<?php

require_once('/usr/local/www/berogui/includes/Helper/Helper.php');
require_once('/usr/fallback/beroConf.php');


function redirect_log($m) {
	$logfile="/var/log/redirect.log";
//	echo $m."\n";
	file_put_contents($logfile, Helper::getDate()." ".$m.PHP_EOL, FILE_APPEND);
}

try {
	$bc = new beroConf('root');

	$params=array('serial'=> Helper::getSerial(),
		 'mac' => Helper::getNetworkMacAddr(Helper::getNetworkIfaceByName('lan')),
		 'task' => "provisioning-url");
	
	$redirect_server = $bc->get('root','redirect_server');	
	if (!strlen($redirect_server)) $redirect_server = 'https://berocloud.beronet.com/api/redirect';
	redirect_log("using '".$redirect_server."'");	
 
	$curl_opts = array( 	CURLOPT_URL => $redirect_server,
				CURLOPT_SSL_VERIFYPEER => 0,
				CURLOPT_RETURNTRANSFER => 1,
				CURLOPT_TIMEOUT => 30,
				CURLOPT_POST => true,
				CURLOPT_SSL_CIPHER_LIST => "AES256-SHA",
				CURLOPT_POSTFIELDS => $params
				); 
			
	$ch = curl_init();
	curl_setopt_array($ch, $curl_opts);
	
	$result = curl_exec($ch);
	redirect_log("result: ". $result);
	$r = unserialize($result);
	redirect_log("unserialized: ". print_r($r,true));
	
	switch($r['task']['type']) {
		case 'cloud-register':
			redirect_log("cloud-register");		
			$bc->set('root', 'cloud_enable', '1');
			$bc->set('root', 'cloud_key', $r['task']['key']);
		break;
		case 'provisioning-url':
			redirect_log("set provisioning url and enable provisioning");
			$bc->set('root', 'provisioning_url', $r['task']['url']);
			$bc->set('root', 'provisioning_mode', 'always');
			$bc->set('root', 'provisioning_manual', '1');
		break;
		case 'cmd':
			redirect_log("start a cmd:'".$r['task']['cmd']."'");
			system($r['task']['cmd'], $out);
			redirect_log("cmd-output:'".$out."'");
		break;
		default:
		redirect_log("do nothing");
	}


} catch(Exception $e) {
	file_put_contents('/var/log/redirect-error.log' , $e->getMessage(). ' ' .$e->getFile(). ' ' .$e->getLine() . "\n" , FILE_APPEND);
}
?>
